const socket = io();

socket
  .on('channels', channels => {
    channels.forEach(channel => {
      const column = document.createElement('div');
      column.classList.add('column');

      const card = getCard(channel);

      column.appendChild(card);

      columns.appendChild(column);
    });
    buttonChannel.classList.remove('is-loading');
  });

function getCard(channel) {
  const card = document.createElement('div');
  card.classList.add('card');
  const header = getHeader(channel);
  card.appendChild(header);
  const cardImage = getCardImage(channel);
  card.appendChild(cardImage);
  const cardContent = getCardContent(channel);
  card.appendChild(cardContent);
  return card;
}

function getCardContent(channel) {
  const cardContent = document.createElement('div');
  cardContent.classList.add('card-content');
  const content = document.createElement('div');
  content.classList.add('content');
  content.textContent = channel.description;
  cardContent.appendChild(content);
  return cardContent;
}

function getCardImage(channel) {
  const cardImage = document.createElement('div');
  cardImage.classList.add('card-image');
  const figure = document.createElement('figure');
  figure.classList.add('image');
  figure.classList.add('is-64x64');
  const img = document.createElement('img');
  img.src = channel.url;
  img.alt = "Channel image";
  figure.appendChild(img);
  cardImage.appendChild(figure);
  return cardImage;
}

function getHeader(channel) {
  const header = document.createElement('header');
  header.classList.add('card-header');
  const p = document.createElement('p');
  p.classList.add('card-header-title');
  p.textContent = channel.title;
  header.appendChild(p);
  return header;
}

function sendChannel() {
  buttonChannel.classList.add('is-loading');
  socket.emit('channel', inputChannel.value);
}